package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLVector_userImport) ENABLED START ***/
import java.util.Collection;
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLVector extends JNIObject  {
	
	/* @generated */
	protected ISLVector(long ptr) {
		/*** PROTECTED REGION ID(ISLVector_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLVector build(long ptr) {
		return new ISLVector(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLVector_userCode) ENABLED START ***/
	public static ISLVector buildFrom(ISLContext ctx, Collection<Integer> values) {
		ISLVector vec = ISLVector.build(ISLNative.isl_vec_alloc(getNativePtr(ctx), values.size())); 
		int i=0;
		for(Integer s : values) {
			vec = vec.setElement(i, s);
			i++;
		}
		return vec;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_vec_alloc 
	 * 
	 * @generated
	**/
	 public static ISLVector build(ISLContext ctx, int size) { 
		/*** PROTECTED REGION ID(static_isl_vec_alloc) DISABLED START ***/
		ISLVector res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVector.build(ISLNative.isl_vec_alloc(getNativePtr(ctx), size));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_vec_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_vec_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_vec_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vec_copy 
	 * 
	 * @generated
	**/
	public ISLVector copy() {
		/*** PROTECTED REGION ID(isl_vec_copy) DISABLED START ***/
		ISLVector res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVector.build(ISLNative.isl_vec_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vec_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_vec_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_vec_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vec_size 
	 * 
	 * @generated
	**/
	public int getSize() {
		/*** PROTECTED REGION ID(isl_vec_size) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_vec_size(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vec_get_element_val 
	 * 
	 * @generated
	**/
	public ISLVal getElementVal(int pos) {
		/*** PROTECTED REGION ID(isl_vec_get_element_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_vec_get_element_val(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vec_set_element_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLVector setElement(int pos, int v) {
		/*** PROTECTED REGION ID(isl_vec_set_element_si) DISABLED START ***/
		ISLVector res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLVector.build(ISLNative.isl_vec_set_element_si(getNativePtr(this), pos, v));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_vec_set_element_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLVector setElement(int pos, ISLVal v) {
		/*** PROTECTED REGION ID(isl_vec_set_element_val) DISABLED START ***/
		ISLVector res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLVector.build(ISLNative.isl_vec_set_element_val(getNativePtr(this), pos, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLVector_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
